#include <iostream>
#include <string>
#include "MemAcc.h"

using namespace std;

// Get the BIOS date
string GetBIOSDate()
{
  int i;
  char c;
  string s;

//  s.clear();
  for(i = 1; i <= 10; i++)
  {
      c = maPeekB(V86_To_PhyAddress(0xFFFF, i + 4));
      if(c == 0)
      {
        break;
      }
      s += c;
  }
  return s;
}

int main(int argc, char* argv[])
{
  char sError[255];

  cout << "MemAccess Library Console sample" << endl;
  cout << "Copyright (c) 1999-2006 Zeal SoftStudio." << endl << endl;

  // After register MemAccess Library,
  // place your registration information here.
  maLicenseInfo("Your name", 0);

  // Open the library
  if(!maOpenLibrary())
  {
      maGetLastState(sError);
      cerr << "Error: " << sError << endl;
      return -1;
  }

  int i, nAddress;

  // COM ports
  for(i = 1; i <= 4; i++)
  {
      nAddress = maPeekW(0x400 + (i - 1) * 2);
      if(maGetLastState(sError) != ERROR_SUCCESS)
      {
        cerr << "Error: " << sError << endl;
        return -1;
      }
      else if(nAddress)
      {
        cout << "COM" << i << ": 0x" << hex << nAddress << endl;
      }
      else
      {
        cout << "COM" << i << ": absent" << endl;
      }
  }

  // LPT ports
  for(i = 1; i <= 3; i++)
  {
      nAddress = maPeekW(0x408 + (i - 1) * 2);
      if(maGetLastState(sError) != ERROR_SUCCESS)
      {
        cerr << "Error: " << sError << endl;
        return -1;
      }
      else if(nAddress)
      {
        cout << "LPT" << i << ": 0x" << hex << nAddress << endl;
      }
      else
      {
        cout << "LPT" << i << ": absent" << endl;
      }
  }

  cout << "BIOS Date: " << GetBIOSDate() << endl;

  // Close the library
  maCloseLibrary();

  cout << "Done!" << endl;

  char any_key;
  cout << "Press any key to continue.";
  cin.get(any_key);
  cout << "\n\n"; 
  return 0;
}



